#include "NOPackage.h"
#include "NOFontVector.h"
#include "NOPage.h"
#include "NOString.h"

using namespace NiXPSObjects;

void createPage(const UTF8Char *pFontIn, const UTF8Char *pXPSOut)
{
	// new destination document
	NOPackage *lPackage=NOPackage::createPackage(true);
	
	// create a new page in the destination doc
	NOPage lPage=lPackage->getDocument(0).createPage();

	// create fixed page
	NOXFixedPage lContent=lPage.createFixedPage();
	lContent.intialize(300,500);

	// create a canvas
	NOXCanvas lCanvas=lContent.createCanvas(0);
	lCanvas.intialize();
	
	// now, add a font file
	NOFont lFont=lPage.addFont(pFontIn);

	// create a glyphs section in the canvas
	NOXGlyphs lGlyphs=lCanvas.createGlyphs(0);
	
	// initialize this glyphs sections
	//	font size:	10
	//	position:	x:50 y:50
	lGlyphs.intialize(10.,NOString(UTF8String("/")+lFont.getPartName()), 50., 50.);
	
	// set the color of the text
	lGlyphs.setFill(NOString("#FF0000FF"));

	// add the text
	lGlyphs.setUnicodeString(NOString("NiXPS Library is fantastic !!"));

	// write out and close
	lPackage->writePackageToFile(pXPSOut);	
	NOPackage::destroyPackage(lPackage);
}