#include <sstream>

#include "NOPackage.h"
#include "NOPage.h"

using namespace NiXPSObjects;

void extractImage(const UTF8Char *pXPSIn, const UTF8Char *pImageOut)
{
	NOPackage *baseDoc = NOPackage::readPackageFromFile(pXPSIn);
	
	// get the 1st document, the second paged (0-based index!)
	NOPage basePage = baseDoc->getDocument(0).getPage(1);

	NOImageVector lImages(*baseDoc);
	/*UInt32 numberOfImages = */basePage.getImages(lImages);

	// write out the 2nd image to a file
	NOImage lImage = lImages[1];
	lImage.writeImageToFile(pImageOut);

	NOPackage::destroyPackage(baseDoc);
}