
#include <sstream>

#include "NOPackage.h"
#include "NOPage.h"

using namespace NiXPSObjects;

void mergePages(const UTF8Char *pXPSIn1, const UTF8Char *pXPSIn2, const UTF8Char *pXPSOut)
{
	// get references to the packages we are going to merge
	NOPackage *lPackage1=NOPackage::readPackageFromFile(pXPSIn1);
	NOPackage *lPackage2=NOPackage::readPackageFromFile(pXPSIn2);

	// create the output package
	// parameter 'true' means: do create an initial document in the new package
	NOPackage *lPackageOut=NOPackage::createPackage(true);
	
	UInt32 lCount;

	// get a handle to the first doc in package 1
	NODocument lSourceDoc1=lPackage1->getDocument(0);

	// copy all pages
	for (lCount=0; lCount<lSourceDoc1.getNumberOfPages(); lCount++)
		lPackageOut->getDocument(0).insertPage(lSourceDoc1.getPage(lCount),0);

	// get a handle to the first doc in package 2
	NODocument lSourceDoc2=lPackage2->getDocument(0);

	// copy pages
	for (lCount=0; lCount<lSourceDoc2.getNumberOfPages(); lCount++)
		lPackageOut->getDocument(0).insertPage(lSourceDoc2.getPage(lCount),0);

	// write out the result
	lPackageOut->writePackageToFile(pXPSOut);
	
	// celan-up
	NOPackage::destroyPackage(lPackage1);
	NOPackage::destroyPackage(lPackage2);
	NOPackage::destroyPackage(lPackageOut);
}