#include <iostream>

#include "NOException.h"
#include "NOPackage.h"

using namespace NCommon;
using namespace NiXPSObjects;

extern void mergePages(const UTF8Char *pXPSIn1, const UTF8Char *pXPSIn2, const UTF8Char *pXPSOut);
extern void createPackage(const UTF8Char *pXPSIn, const UTF8Char *pXPSOut);
extern void replaceFont(const UTF8Char *pXPSIn, const UTF8Char *pFontIn, const UTF8Char *pXPSOut);
extern void getThumbnail(const UTF8Char *pXPSIn, const UTF8Char *pImageOut);
extern void overlayPage(const UTF8Char *baseXPSdoc, const UTF8Char *overlayXPSdoc, const UTF8Char *pOut);
extern void extractImage(const UTF8Char *pXPSIn, const UTF8Char *pImageOut);
extern void renderPage(const UTF8Char *pXPSIn, const UTF8Char *pXPSOut, const UInt32 lPageNumber);

int main (int argc, char * const argv[]) 
{
#ifdef win32
	const UTF8String lPath="../";
#else
	const UTF8String lPath="../../";
#endif
	
	const UTF8String lFile1=lPath+"testfiles/Office2007.xps";
	const UTF8String lFile2=lPath+"testfiles/Thumbnail.xps";
	const UTF8String lFile3=lPath+"testfiles/vdp.xps";
	const UTF8String lFile4=lPath+"testfiles/printarea08.xps";
	const UTF8String lFile5=lPath+"testfiles/CoreProperty2.xps";
	const UTF8String lFontFile=lPath+"testfiles/Arial";

	const UTF8String lOutput1=lPath+"output/out1.xps";
	const UTF8String lOutput2=lPath+"output/out2.xps";
	const UTF8String lOutput3=lPath+"output/out3.xps";
	const UTF8String lOutput4=lPath+"output/out4.jpg";
	const UTF8String lOutput5=lPath+"output/out5.xps";
	const UTF8String lOutput6=lPath+"output/out6.jpg";
	const UTF8String lOutput7=lPath+"output/out7.tiff";

	try
	{	
		std::ostream &os=std::cout;
		
		os << "mergePages test ..." << std::endl;
		mergePages(lFile1.c_str(), lFile2.c_str(), lOutput1.c_str());
		 
		os << "createPackage test ..." << std::endl;
		createPackage(lFile1.c_str(), lOutput2.c_str());

		os << "replaceFont test ..." << std::endl;
		replaceFont(lFile3.c_str(), lFontFile.c_str(), lOutput3.c_str());

		os << "getThumbnail test ..." << std::endl;
		getThumbnail(lFile3.c_str(), lOutput4.c_str());

		os << "overlayPage test ..." << std::endl;
		overlayPage(lFile2.c_str(), lFile3.c_str(), lOutput5.c_str());

		os << "extractImage test ..." << std::endl;
		extractImage(lFile1.c_str(), lOutput6.c_str());

		os << "renderPage test ..." << std::endl;
		renderPage(lFile1.c_str(), lOutput7.c_str(), 0);
	} catch (NOException e)
	{
		std::cout << "!! ERROR CODE: 0x" << std::hex << e.getError();
	}
    return 0;
}
