// NOFontVector
//
// (c) NiXPS NV, May 2007

#ifndef _NOFONTVECTOR_H_
#define _NOFONTVECTOR_H_

/*! \file NOFontVector.h
    \brief Header file for NOFontVector class
*/

#include "NOVector.h"
#include "NOFont.h"
#include "NOPackage.h"

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

class NOPartBased;
class NODocument;

/*!
 * \class NOFontVector NOFontVector.h "NOFontVector.h"
 * Class managing a vector of fonts
 */
class NOFontVector: public NOVector
{
	public:
		/// Create a font vector consisting of the fonts in this package
		/// @param pPackage The package to get the fonts from
		NOFontVector(NOPackage &pPackage);

		/// destructor
		virtual ~NOFontVector();
		
		/// Returns the font at given index as an NOFont object representation
		/// @param pIndex The index of the font to obtain (0-based)
		NOFont operator[](const NCommon::UInt32 &pIndex) const;
};

}

#endif // NIXPS_CPP_INTERFACE
#endif
