// NOPartBased.h
//
// NOPartBased:	base class for all NiXPSObjects based on a part
//			
//
// (c) NiXPS NV, October 2006

#ifndef _NOPARTBASED_H_
#define _NOPARTBASED_H_

//#include "NOBase.h"
#include "NTPartType.h"
#include "NTypes.h"

// C api
extern "C" {
	DLLIMPORTEXPORT NOHandler NOHandler_empty();
	DLLIMPORTEXPORT NOHandler NOHandler_new(NOHandler* pHandler, NCommon::UInt16 pID, NCommon::UInt32 pType);
	DLLIMPORTEXPORT NCommon::UInt32 NOHandler_doesExist(NOHandler* pHandler);
	DLLIMPORTEXPORT void NOHandler_getPartName(NOHandler* pHandler, NOStringHandler *pString);
};

// C++ api
#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

class NOPartBased/*: public NOBase*/
{
	protected:
		NOHandler mHandler;		

		// default constructor
		NOPartBased();

	public:
		// constructor: object is always linked to a specific package and a part ID
		NOPartBased(const NOHandler pHandler);

		// destructor
		virtual ~NOPartBased();
		
		// test for emptyness
		const bool isEmpty() const;

		// get the part id
		NCommon::UInt16 getPartID() const;

		// get a pointer to the handler
		NOHandler *getNOHandler();

		// get a const pointer to the handler
		const NOHandler *getNOHandler() const;

		// get the name of this part
		NCommon::UTF8String getPartName() const;
};

}
#endif // NIXPS_CPP_INTERFACE
#endif
