// NOPartWithResources.h
//
// NOPartWithResources: a part that has resources like fonts and images, and a thumbnail
//			
//
// (c) NiXPS NV, April 2007

/*! \file NOPartWithResources.h
    \brief Header file for NOPartWithResources class
*/

#ifndef _NOPARTWITHRESOURCES_H_
#define _NOPARTWITHRESOURCES_H_

#include "NOXMLPartBased.h"
#include "NOThumbnail.h"

// C api
extern "C"
{	
	DLLIMPORTEXPORT NCommon::UInt32				NOPartWithResources_hasThumbnail(NOPartWithResourcesHandler* pThumbnailHandler);
	DLLIMPORTEXPORT NOThumbnailHandler			NOPartWithResources_getThumbnail(NOPartWithResourcesHandler* pThumbnailHandler);
}

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

using namespace NCommon;
using namespace NiXPSAccess;

class NiXPSAccess::NAPackage;

/*!
 * \class NOPartWithResources NOPartWithResources.h "NOPartWithResources.h"
 * Base class for parts in an XPS file that have resources (currently only thumbnails are supported)
 */
class  NOPartWithResources: public NOXMLPartBased
{
	protected:
		NOPartWithResources();
		
	public:
		NOPartWithResources(const NOHandler pHandler);
		virtual ~NOPartWithResources();

		/// Returns whether or not a part has a thumbnail
		bool hasThumbnail();

		/// Returns a thumbnail object representing the thumbnail for this specific part
		const NOThumbnail getThumbnail();
};

}
#endif // NIXPS_CPP_INTERFACE

#endif
