// NOXPathGeometry header file - Auto-generated from the XSD schema
//
// (c) NDR 2007, NiXPS NV, All rights reserved

#ifndef _NOXPathGeometry_h_
#define _NOXPathGeometry_h_

/*! \file NOXPathGeometry.h
	\brief Header file for the NOXPathGeometry class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXPathGeometry_getPathGeometryTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathGeometry_getNumPathGeometryTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathGeometry_createPathGeometryTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPathGeometry_getPathFigure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathGeometry_getNumPathFigure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathGeometry_createPathFigure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXPathGeometry_getFigures(NOXHandler *pHandler, NOXAbbrGeom *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathGeometry_hasFigures(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathGeometry_setFigures(NOXHandler *pHandler, NOXAbbrGeom pObject);
DLLIMPORTEXPORT void NAXPathGeometry_getFillRule(NOXHandler *pHandler, NOXFillRule *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathGeometry_hasFillRule(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathGeometry_setFillRule(NOXHandler *pHandler, NOXFillRule pObject);
DLLIMPORTEXPORT NOXFillRule NAXPathGeometry_getDefaultFillRule();
DLLIMPORTEXPORT void NAXPathGeometry_getTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathGeometry_hasTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathGeometry_setTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
/// Initialize
DLLIMPORTEXPORT void NAXPathGeometry_intialize(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPathGeometry NOXPathGeometry.h "NOXPrefix.h"
 * Class NOXPathGeometry
 */
class NOXPathGeometry
{
	public:
		NOXHandler mHandler;
		NOXPathGeometry()
		{
			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPathGeometry(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PathGeometryTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		NOXCP_Transform NOXPathGeometry::getPathGeometryTransform(NCommon::UInt32 pIndex)
		{
			return NAXPathGeometry_getPathGeometryTransform(&mHandler, pIndex);
		}

		/// Calculate the number of PathGeometryTransform elements that are present
		NCommon::UInt32 NOXPathGeometry::getNumPathGeometryTransform()
		{
			return NAXPathGeometry_getNumPathGeometryTransform(&mHandler);
		}

		/// Create an PathGeometryTransform element at index pIndex
		NOXCP_Transform NOXPathGeometry::createPathGeometryTransform(NCommon::UInt32 pIndex)
		{
			return NAXPathGeometry_createPathGeometryTransform(&mHandler, pIndex);
		}

		/// Get PathFigure element at index pIndex
		/// @param pIndex index of the element you want to get
		NOXPathFigure NOXPathGeometry::getPathFigure(NCommon::UInt32 pIndex)
		{
			return NAXPathGeometry_getPathFigure(&mHandler, pIndex);
		}

		/// Calculate the number of PathFigure elements that are present
		NCommon::UInt32 NOXPathGeometry::getNumPathFigure()
		{
			return NAXPathGeometry_getNumPathFigure(&mHandler);
		}

		/// Create an PathFigure element at index pIndex
		NOXPathFigure NOXPathGeometry::createPathFigure(NCommon::UInt32 pIndex)
		{
			return NAXPathGeometry_createPathFigure(&mHandler, pIndex);
		}

		/// Get the Figures attribute
		NOXAbbrGeom NOXPathGeometry::getFigures()
		{
			NOXAbbrGeom lHandler;
			NAXPathGeometry_getFigures(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Figures attribute
		bool NOXPathGeometry::hasFigures()
		{
			return (NAXPathGeometry_hasFigures(&mHandler)!=0);
		}

		/// Sets the Figures attribute
		void NOXPathGeometry::setFigures(NOXAbbrGeom pObject)
		{
			NAXPathGeometry_setFigures(&mHandler, pObject);
		}

		/// Get the FillRule attribute
		NOXFillRule NOXPathGeometry::getFillRule()
		{
			NOXFillRule lHandler;
			NAXPathGeometry_getFillRule(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the FillRule attribute
		bool NOXPathGeometry::hasFillRule()
		{
			return (NAXPathGeometry_hasFillRule(&mHandler)!=0);
		}

		/// Sets the FillRule attribute
		void NOXPathGeometry::setFillRule(NOXFillRule pObject)
		{
			NAXPathGeometry_setFillRule(&mHandler, pObject);
		}

		/// Get the default FillRule
		NOXFillRule NOXPathGeometry::getDefaultFillRule()
		{
			return NAXPathGeometry_getDefaultFillRule();
		}

		/// Get the Transform attribute
		NOXRscRefMatrix NOXPathGeometry::getTransform()
		{
			NOXRscRefMatrix lHandler;
			NAXPathGeometry_getTransform(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Transform attribute
		bool NOXPathGeometry::hasTransform()
		{
			return (NAXPathGeometry_hasTransform(&mHandler)!=0);
		}

		/// Sets the Transform attribute
		void NOXPathGeometry::setTransform(NOXRscRefMatrix pObject)
		{
			NAXPathGeometry_setTransform(&mHandler, pObject);
		}

		/// Initialize
		void intialize()
		{
			NAXPathGeometry_intialize(&mHandler);
		}
};

}

#endif
