// NTImageFormat.h
//
// (c) NiXPS NV, April 2007

#ifndef _NTIMAGEFORMAT_H_
#define _NTIMAGEFORMAT_H_

/*! \file NTImageFormat.h
    \brief Header file for image types
*/
namespace NCommon
{

namespace Image
{

typedef enum {
	unknown = 0,	/**< Unknown image format */
	png		= 1,	/**< PNG image file */
	tiff	= 2,	/**< TIFF image file */
	jpeg	= 3,	/**< JPEG image file */
	hdphoto	= 4		/**< Windows Media Photo file, now called 'HD Photo' */
} Format;

typedef enum {
	GRAY			= 0,
	GRAYA			= 1,
	PALETTE			= 2,
	RGB				= 3,
	ARGB			= 4		
} ColorType;

typedef enum {
	B1				= 0,
	B2				= 1,
	B4				= 2,
	B8				= 3,
	B16				= 4
} BitDepth;
		
/*! \typedef NCommon::Image::Format
 *  A description of the enum type.
 */

/*! \namespace NCommon::Image
 *  The namespace for the Image related types and methods
 */

}

};

#endif

