// NOCorePropertiesDLL.cpp
//
// NOCoreProperties: CoreProperties class
//			
// (c) NiXPS NV, Juni 2007

/*! \file NOCoreProperties.cpp
    \brief Implementation of the NOCoreProperties class
*/

#include "NTypes.h"
#include "NTCorePropertyType.h"

#include "NOException.h"
#include "NOXMLPartBased.h"
#include "NOCoreProperties.h"

class NOPackage;

using namespace NiXPSAccess;

NiXPSObjects::NOCoreProperties::NOCoreProperties(NOCorePropertiesHandler pHandler) : NOXMLPartBased(pHandler)
{
}

// destructor
NiXPSObjects::NOCoreProperties::~NOCoreProperties()
{
}

// get property
const NCommon::UTF8String NiXPSObjects::NOCoreProperties::getProperty(NCommon::CoreProperty::Type pType)
{
	NOString lStr;
	NOCoreProperties_getProperty(&mHandler, pType, lStr.getHandler());
	if (mHandler.mError)
		throw(NOException(mHandler));

	return lStr.getUTF8String();
}

void NiXPSObjects::NOCoreProperties::setProperty(NCommon::CoreProperty::Type pType, const NCommon::UTF8String &pString)
{
	NOCoreProperties_setProperty(&mHandler, pType, pString.c_str());

	if (mHandler.mError)
		throw(NOException(mHandler));
}
