// NOPartBased.cpp
//
// NOPartBased:	base class for all NiXPSObjects based on a part
//			
//
// (c) NiXPS NV, October 2006

#include "NOPartBased.h"
#include "NOString.h"
#include "NOException.h"

namespace NiXPSObjects
{

NOPartBased::NOPartBased()
{
	mHandler.mPackage=0;
	mHandler.mID=0;	
	mHandler.mType=NCommon::Part::Unknown;
	mHandler.mError=0;
}

// constructor: object is always linked to a specific package and a part ID
//NOPartBased::NOPartBased(NiXPSAccess::NAPackage *pPackage, const UInt16 &pID, Part::Type pType): NOBase(pPackage)
NOPartBased::NOPartBased(const NOHandler pHandler): mHandler(pHandler)/*, NOBase(pHandler.mPackage)*/
{
}

// destructor
NOPartBased::~NOPartBased()
{
}
		
const bool NOPartBased::isEmpty() const
{
	return !mHandler.mPackage;
}

NOHandler* NOPartBased::getNOHandler()
{
	return &mHandler;
}

const NOHandler* NOPartBased::getNOHandler() const
{
	return &mHandler;
}

// get the part id
NCommon::UInt16 NOPartBased::getPartID() const
{
	return mHandler.mID;
}

// get the name of this part
NCommon::UTF8String NOPartBased::getPartName() const
{
	NOString lName;
	NOHandler_getPartName(const_cast<NOPartBased *>(this)->getNOHandler(),lName.getHandler());

	if (mHandler.mError)
		throw(NOException(mHandler));

	return lName.getUTF8String();
}

/*
NAPackage* NOPartBased::getNAPackage() const
{
	if (!mHandler.mPackage)
		NATHROW(ERR_OBJECT_NO_PACKAGE);
	return *mHandler.mPackage;
}
*/
}
