// NOPartWithResources.h
//
// NOPartWithResources: a part that has resources like fonts and images, and a thumbnail
//			
// (c) NiXPS NV, April 2007

/*! \file NOPartWithResources.cpp
    \brief Implementation of the NOPartWithResources class
*/

#include "NOPartWithResources.h"
#include "NOException.h"

namespace NiXPSObjects
{

// constructor
NOPartWithResources::NOPartWithResources(): NOXMLPartBased()
{
}

// constructor: object is always linked to a specific package (and probably also a specific part)
NOPartWithResources::NOPartWithResources(const NOHandler pHandler): NOXMLPartBased(pHandler)
{
}

// destructor
NOPartWithResources::~NOPartWithResources()
{
}

bool NOPartWithResources::hasThumbnail()
{
	NCommon::UInt32 lRet=NOPartWithResources_hasThumbnail(getNOHandler());

	if (mHandler.mError)
		throw(NOException(mHandler));

	return (lRet!=0);
}

// returns the NOThumbnail object
const NOThumbnail NOPartWithResources::getThumbnail()
{
	NOThumbnailHandler lHandler=NOPartWithResources_getThumbnail(getNOHandler());

	if (mHandler.mError)
		throw(NOException(mHandler));

	return NOThumbnail(lHandler);
}

}
