// NOString.cpp
//
// NOString
//
// (c) NiXPS NV, May 2007

/*! \file NOString.cpp
    \brief Implementation of the NOString class
*/

#include "NOString.h"

namespace NiXPSObjects
{

// constructor: object is always linked to a specific package (and probably also a specific part)
NOString::NOString()
{
	mHandler=NOString_new();
}

NOString::NOString(const UTF8String &pIn)
{
	mHandler=NOString_newWithCString(const_cast<UTF8Char *>(pIn.c_str()));
}

// destructor
NOString::~NOString()
{
	NOString_delete(&mHandler);
}

// get handler
NOStringHandler* NOString::getHandler()
{
	return &mHandler;
}

// get pointer to string
const NCommon::UTF8String NOString::getUTF8String()
{
	return NOString_c_str(&mHandler);
}

// returns the size of the vector
NCommon::UInt32 NOString::size()
{
	return NOString_size(&mHandler);
}

}

