// NOThumbnail.cpp
//
// NOThumbnail: NOThumbnail class
//
// (c) NiXPS NV, June 2007

/*! \file NOThumbnail.cpp
    \brief Implementation of the NOThumbnail class
*/

#include "NOThumbnail.h"
#include "NOPackage.h"
#include "NOException.h"
	
NiXPSObjects::NOThumbnail::NOThumbnail(): NOPartBased() 
{
}

NiXPSObjects::NOThumbnail::NOThumbnail(const NOThumbnailHandler pHandler): NOPartBased(pHandler) {}

// destructor
NiXPSObjects::NOThumbnail::~NOThumbnail() {};

// get image size
NCommon::UInt32 NiXPSObjects::NOThumbnail::getImageSize()
{
	UInt32 lRet=NOThumbnail_getImageSize(getNOHandler());

	if (mHandler.mError)
		throw(NOException(mHandler));

	return lRet;
}

// get image data
bool NiXPSObjects::NOThumbnail::getImageData(NCommon::UInt8 *pBuffer, NCommon::UInt32 pSize)
{
	UInt32 lRet=NOThumbnail_getImageData(getNOHandler(),pBuffer,pSize);

	if (mHandler.mError)
		throw(NOException(mHandler));

	return (lRet!=0);
}
