// NOVector.cpp
//
// NOVector
//
// (c) NiXPS NV, May 2007

/*! \file NOVector.cpp
    \brief Implementation of the NOVector class
*/

#include "NOVector.h"
#include "NOPartBased.h"

using namespace NCommon;

void NiXPSObjects::NOVector::addPart(NOHandler &mPart)
{
	NOVector_addPart(mHandler,mPart);
}

void NiXPSObjects::NOVector::addPartID(const UInt16 &mPartID)
{
	NOVector_addPartID(mHandler,mPartID);
}

const UInt16 NiXPSObjects::NOVector::getPartIDAtIndex(const UInt32 &pIndex) const
{
	return NOVector_getPartIDAtIndex(mHandler, pIndex);
}

NiXPSObjects::NOVector::NOVector(NiXPSAccess::NAPackage *pPackage) : mHandler(NOVector_new(pPackage))
{
}

NiXPSObjects::NOVector::~NOVector()
{
	NOVector_delete(&mHandler);
}
		
NOVectorHandler NiXPSObjects::NOVector::getHandler()
{
	return mHandler;
}
		
NCommon::UInt32 NiXPSObjects::NOVector::size() const
{
	return NOVector_size(mHandler);
}
