// NOXMLPartBased.cpp
//
// NOXMLPartBased:	base class for all NiXPSObjects based on an xml part
//			
// (c) NiXPS NV, April 2007

/*! \file NOThumbnail.cpp
    \brief Implementation of the NOXMLPartBased class
*/

#include "NOXMLPartBased.h"
#include "NOException.h"

namespace NiXPSObjects
{

using namespace NiXPSAccess;

NOXMLPartBased::NOXMLPartBased(): NOPartBased()
{
}

NOXMLPartBased::NOXMLPartBased(const NOHandler pHandler): NOPartBased(pHandler)
{	
}

NOXMLPartBased::~NOXMLPartBased()
{
}

NOContentStreamNavigator NOXMLPartBased::getContentStreamNavigator()
{
	return NOContentStreamNavigator(*this);
}

void NOXMLPartBased::getContentStream(UTF8Char *pBuffer, UInt32 pSize)
{
	NOXMLPartBased_getContentStream(getNOHandler(),pBuffer,pSize);
	
	if (mHandler.mError)
		throw(NOException(mHandler));
}

NCommon::UInt32 NOXMLPartBased::getContentStreamLength()
{
	UInt32 lRet=NOXMLPartBased_getContentStreamLength(getNOHandler());

	if (mHandler.mError)
		throw(NOException(mHandler));
		
	return lRet;
}

void NOXMLPartBased::replaceContentStream(const UTF8Char *pBuffer, const UInt32 &pLen)
{
	NOXMLPartBased_replaceContentStream(getNOHandler(),pBuffer,&pLen);

	if (mHandler.mError)
		throw(NOException(mHandler));
}

}
